//--------------------------------------------------------------------------------
//  Main window base class for D v0.1.0
//    Copyright (c) kei mesuda 2006
//--------------------------------------------------------------------------------
module util_win.mainwindow;

private import std.string;
public  import win32.windows;

private import util_win.global;
public  import util_win.window;




//--------------------------------------------------------------------------------
//  Main window template
//--------------------------------------------------------------------------------
class TMainWindow(T) : public IMainWindow
{
public:
    static this()
    {
        s_mainWindow = new T;
    }
}




//--------------------------------------------------------------------------------
//  Main window class
//--------------------------------------------------------------------------------
class IMainWindow : IWindow
{
//----------------------------------------------------------------------
// Member value
//----------------------------------------------------------------------
protected:
    static IMainWindow  s_mainWindow;   // Pointer to main fiber instance




//----------------------------------------------------------------------
// Constructor
//----------------------------------------------------------------------
public:
    this()
    {
    }




//----------------------------------------------------------------------
// Instance
//----------------------------------------------------------------------
public:
    // Get main fiber instance
    static IMainWindow getInstance()
    {
        return s_mainWindow;
    }


    // Get instance handle
    HINSTANCE getInstanceHandle()
    {
        return g_hInstance;
    }
    
    
    // Get module name
    char[] getModuleName()
    {
        return g_nameModule;
    }


    // Set class name
    void setClassName(char[] name)
    {
        g_nameClass = name;
    }




//----------------------------------------------------------------------
//  Virtual functions; 
//----------------------------------------------------------------------
public:
    // Main routine calls this first of all.
    void enterInstance(char[][] arg)
    {
        enterInstance();
    }
    
    // Main routine calls this first of all.
    void enterInstance()
    {
    }
    
    
    // Main routine calls this at the end.
    void exitInstance()
    {
    }


    // And also virtual function if IWindow
    // bool idle()
    // bool proc(HWND, uint, WPARAM, LPARAM)
}


